/***************************************************************************
                          texdat.h  -  description
                             -------------------
    begin                : Wed Jul 26 2000
    copyright            : (C) 2000 by Simon E. Reichelt
    email                : s.reichelt@gmx.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#ifndef TEXDAT_H
#define TEXDAT_H 1

#include <gtk/gtk.h>
#include <stdio.h>

#include "wadfile.h"


typedef struct
{
	char name[16];
	unsigned width;
	unsigned height;
	byte_t *pxm_data;
	byte_t *zero_offs;
	GdkRgbCmap *clr_map;
	GtkWidget *d_area;
	int index;
	short off_s;
} texrep_t;


typedef struct
{
	short magic_n;
	char storage;
	char bpc;
	unsigned short dimension;
	unsigned short x_size;
	unsigned short y_size;
	unsigned short z_size;
	long pix_min;
	long pix_max;
	char dummy[4];
	char img_name[80];
	long colormap;
	char dummy2[404];
} sgi_header_t;


byte_t *GetWAD2PalettePos(byte_t *ram_file);

byte_t *DrawCmapPixmap(void);

int GetMemOffset(int width, int height);

void GetRealSize(texrep_t *tex, int *width, int *height);

int GetMiptexInfo(texrep_t *texture, miptex_t *miptex, int offset);

void FlushBackground(GdkPixmap *xpm, GdkGC *gc, int width, int height);

void CorrectIndex(texrep_t *tex1, texrep_t *tex2);

void SortCacheTextures(texrep_t *tex_set, int tex_cnt);

void RenderMipmap(byte_t **d_pxm, byte_t *tex_read, int offset);

texrep_t *CacheWadTextures(FILE *w_file, GdkGC *gc);

int RedrawTex(GtkWidget *emitter, GdkEvent *event, gpointer data);

void FreeTextures(texrep_t *tex_pointer);

int WriteSGIFile(char f_name[], texrep_t *tex_entry);

void TruncateTextureName(char target_pos[], char tex_name[]);

#endif